diff --git a/ospfd/ospf_asbr.c b/ospfd/ospf_asbr.c
index bf6f0b161490..5baad1754d5a 100644
--- a/ospfd/ospf_asbr.c
+++ b/ospfd/ospf_asbr.c
@@ -987,6 +987,7 @@ static void ospf_handle_external_aggr_update(struct ospf *ospf)
 				&aggr->match_extnl_hash,
 				(void *)ospf_aggr_handle_external_info);
 
+			ospf_external_aggregator_free(aggr);
 		} else if (aggr->action == OSPF_ROUTE_AGGR_MODIFY) {
 
 			aggr->action = OSPF_ROUTE_AGGR_NONE;
